欢迎您访问程序员文章站本站旨在为大家提供分享程序员计算机编程知识!
您现在的位置是: 首页

LeetCode每日一题 (38) 530. 二叉搜索树的最小绝对差 (中序遍历)

程序员文章站 2022-04-24 16:28:18
...

530. 二叉搜索树的最小绝对差


LeetCode每日一题 (38) 530. 二叉搜索树的最小绝对差 (中序遍历)
LeetCode每日一题 (38) 530. 二叉搜索树的最小绝对差 (中序遍历)


/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode(int x) : val(x), left(NULL), right(NULL) {}
 * };
 */
class Solution {
public:
    int getMinimumDifference(TreeNode* root) {
        vector<int> L; // 定义一个数组,用来保存每一个节点的值
        queue<TreeNode* > Q; 
        TreeNode* p;
        Q.push(root);
        // 将树遍历一遍,然后将每一个节点的值加入到数组L中
        while(!Q.empty()){
            p=Q.front();
            L.push_back(p->val);
            Q.pop();
            if(p->left!=nullptr){
                Q.push(p->left);
            }
            if(p->right!=nullptr){
                Q.push(p->right);
            }
        }
        // 将L从小到大排序,然后就可以依次计算每两个值的差,纪录下差值最小的就好了
        sort(L.begin(),L.end());
        int min=L[1]-L[0];
        for(int i=1;i<L.size();i++){
            if(L[i]-L[i-1]<min){
                min=L[i]-L[i-1];
            }
        }
        return min;
    }
};

LeetCode每日一题 (38) 530. 二叉搜索树的最小绝对差 (中序遍历)


class Solution {
public:
    // 1. 这是一颗搜索树,所以它的中序遍历就是递增的
    // 2. 两点节点相差最小(递增)-->这两个节点肯定相邻
    int getMinimumDifference(TreeNode* root) {
        int min=1111111,preValue=-1;
        dfs(root,preValue,min);
        return min;
    }
    void dfs(TreeNode* root,int &preValue, int &min){
        if(root==nullptr) return;
        if(root->left!=nullptr){
            dfs(root->left,preValue,min);
        }
        if(preValue!=-1){
            int t=root->val - preValue;
            if(t<min) min=t;
        }
        preValue=root->val;
        if(root->right!=nullptr){
            dfs(root->right,preValue,min);
        }
    }
};

LeetCode每日一题 (38) 530. 二叉搜索树的最小绝对差 (中序遍历)


class Solution {
public:
    // 1. 这是一颗搜索树,所以它的中序遍历就是递增的
    // 2. 两点节点相差最小(递增)-->这两个节点肯定相邻
    int getMinimumDifference(TreeNode* root) {
        stack<TreeNode*> S;
        TreeNode *p=root;
        int preValue=-1,min=INT_MAX;
        while(p!=NULL || !S.empty()){
            while(p!=NULL){
                S.push(p);
                p=p->left;
            }
            p=S.top();
            S.pop();
            if(preValue!=-1){
                if(p->val - preValue < min){
                    min=p->val - preValue;
                }
            }
            preValue=p->val;
            if(p->right!=NULL){
                p=p->right;
            }
            else{
                p=NULL;
            }
        }
        return min;
    }
};

LeetCode每日一题 (38) 530. 二叉搜索树的最小绝对差 (中序遍历)